﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using Npgsql;
using Macoratti.Entidades;

namespace Macoratti.DAL
{
    public class AlunoDAL : IAcessoDadosObject<Aluno>
    {
        private DALHelper dal = new DALHelper();

        public Aluno Get<K>(K id)
        {
            Aluno aluno = new Aluno();
            NpgsqlDataReader reader = null;

            try
            {
            string query = "SELECT * FROM alunos WHERE alunoid = @id";
            dal.OpenConnection();

            reader = dal.ExecuteDataReader(query);

                while (reader.Read())
                {
                  aluno.Turmaid = Convert.ToInt32(reader["turmaid"]);
                  aluno.Apelido = reader["apelido"].ToString();
                  aluno.Email = reader["email"].ToString();
                  aluno.Nome = reader["nome"].ToString();
                  aluno.Sexo = Convert.ToChar(reader["sexo"]);
                }
                reader.Close();
                //this.dal.CloseConection();
            }
            finally
            {
                if (reader != null)
                {
                reader.Close();
                }
                this.dal.CloseConection();
            }
            return aluno;
        }

        public List<Aluno> GetTop()
        {
            List<Aluno> alunos = new List<Aluno>();

            NpgsqlDataReader reader = null;
            try
            {
                string query = "select * from alunos";
                dal.OpenConnection();
                reader = dal.ExecuteDataReader(query);

                while (reader.Read())
                {
                    Aluno aluno = new Aluno();
                    aluno.Turmaid = Convert.ToInt32(reader["turmaid"]);
                    aluno.Apelido = reader["apelido"].ToString();
                    aluno.Email = reader["email"].ToString();
                    aluno.Nome = reader["nome"].ToString();
                    aluno.Sexo = Convert.ToChar(reader["sexo"]);
                    alunos.Add(aluno);
                }
                reader.Close();
            }
            finally
            {
                if (reader != null)
                {
                    reader.Close();
                }
                this.dal.CloseConection();
            }
            return alunos;
        }

        public void Insert(Aluno oAluno)
        {
             string query = "INSERT INTO alunos (turmaid,apelido,email,nome,sexo) VALUES (@turmaid,@apelido,@email,@nome,@sexo)";
             this.dal.ExecuteNonQuery(query,
             new NpgsqlParameter("turmaid", oAluno.Turmaid),
             new NpgsqlParameter("apelaido", oAluno.Apelido),
             new NpgsqlParameter("email", oAluno.Email),
             new NpgsqlParameter("nome", oAluno.Nome),
             new NpgsqlParameter("sexo", oAluno.Sexo));
        }

        public void Update<K>(K id, Aluno oAluno)
        {
            string query = "INSERT INTO alunos (turmaid,apelido,email,nome,sexo) VALUES (@turmaid,@apelido,@email,@nome,@sexo)";
            this.dal.ExecuteNonQuery(query,
            new NpgsqlParameter("turmaid", oAluno.Turmaid),
            new NpgsqlParameter("apelaido", oAluno.Apelido),
            new NpgsqlParameter("email", oAluno.Email),
            new NpgsqlParameter("nome", oAluno.Nome),
            new NpgsqlParameter("sexo", oAluno.Sexo));
        }

        public void Delete<K>(K id)
        {
            string query = "DELETE FROM alunos WHERE alunoid = @id";
            this.dal.ExecuteNonQuery(query);
        }
    }
}
