﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using Npgsql;

namespace Macoratti.DAL
{
    public class DALHelper
    {
        string server = "localhost";
        string port = "5432";
        string database = "macoratti";
        string userId = "macoratti";
        string userPassword = "numsey";

        public NpgsqlConnection conexaoBD { get; set; }
        public string stringConexaoBD { get; set; }

        public DALHelper()
        {
            this.stringConexaoBD = string.Format("Server={0};Port={1};Database={2};User Id={3};Password={4};", server, port, database, userId, userPassword);
            this.conexaoBD = new NpgsqlConnection(this.stringConexaoBD);
        }

        public DALHelper(string stringConexaoBD)
        {
            this.conexaoBD = new NpgsqlConnection(this.stringConexaoBD);
        }

        public static DALHelper Create()
        {
           return new DALHelper();
        }

        public static DALHelper Create(string stringConexaoBD)
        {
            return new DALHelper(stringConexaoBD);
        }

        public void OpenConnection()
        {
            if (this.conexaoBD.State == System.Data.ConnectionState.Closed)
            {
                this.conexaoBD.Open();
            }
        }

        public void CloseConection()
        {
            this.conexaoBD.Close();
        }

        public void ExecuteNonQuery(NpgsqlCommand command)
        {
          command.ExecuteNonQuery();
        }

        public void ExecuteNonQuery(NpgsqlCommand command, bool openConnection)
        {
             if (openConnection)
             {
                this.OpenConnection();
             }  
             this.ExecuteNonQuery(command);
             if (openConnection)
             {
                this.CloseConection();
             }
        }

        public void ExecuteNonQuery(string consultaSQL, params NpgsqlParameter[] parameters)
        {
            try
            {
                this.OpenConnection();
                NpgsqlCommand command = this.conexaoBD.CreateCommand();
                command.CommandText = consultaSQL;

                command.Parameters.AddRange(parameters);
                
                this.ExecuteNonQuery(command);
                this.CloseConection();
            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
                this.CloseConection();
            }
        }

        public NpgsqlDataReader ExecuteDataReader(string sql, NpgsqlConnection con)
        {
            NpgsqlDataReader dr = null;
            try
            {
                NpgsqlCommand cmd = new NpgsqlCommand(sql, con);
                dr = cmd.ExecuteReader();
                return dr;
            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
                this.CloseConection();
            }
        }
        public NpgsqlDataReader ExecuteDataReader(string sql)
        {
            NpgsqlDataReader dr = null;
            try
            {
                if (this.conexaoBD.State == System.Data.ConnectionState.Closed)
                {
                    this.conexaoBD.Open();
                }

                NpgsqlCommand cmd = new NpgsqlCommand(sql,this.conexaoBD);
                dr = cmd.ExecuteReader();
                return dr;
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        public static NpgsqlDataReader ExecuteDataReader(string sqlStatement,
                                                      params NpgsqlParameter[] arrParam)
        {
            NpgsqlDataReader reader;

            // Define o command
            NpgsqlCommand cmd = new NpgsqlCommand();
            cmd.CommandType = CommandType.Text;
            cmd.CommandText = sqlStatement;

            // trata os parametros
            if (arrParam != null)
            {
                foreach (NpgsqlParameter param in arrParam)
                    cmd.Parameters.Add(param);
            }

            try
            {
                // Executa o reader
                reader = cmd.ExecuteReader();
                return reader;
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
   }
}